/*--------------------------------------------------------------------------------*/
/* 'C' Programming Under WIN32                                     V.Burel (c)2007*/
/*                                                                                */
/*  WEB  : http://pagesperso-orange.fr/vb-audio/fr/pub/programming/index.htm      */
/*  mail : infoprog@vb-audio.com                                                  */
/*--------------------------------------------------------------------------------*/
/*  MinPrg is a minimal program under windows (like a Hello World)                 */
/*--------------------------------------------------------------------------------*/
/*  To compile With Microsoft VC2005 you need to create an empty Win32 project    */
/*  with the following options :                                                  */
/*  - Configuration Properties / General : Char Set = NOT SET                     */
/*  - Configuration Properties / C/C++ / Preprocessor : _CRT_SECURE_NO_DEPRECATE  */
/*--------------------------------------------------------------------------------*/
#ifndef __cplusplus
	#ifndef STRICT
		#define STRICT
	#endif
#endif
#include <windows.h>
#include <stdio.h>
#include "minprg.h"

//
//define globals 
//
static HWND			G_hwnd_MainWindow	=NULL;
static HINSTANCE	G_hinstance			=NULL;





/*******************************************************************************/
/**                                QUIT & ABOUT                               **/
/*******************************************************************************/

void ManageCloseMessage(HWND hw)
{
	int rep;
	char titre[]="Close Application...";
	char message[512];
	
	//Get the string from resource, otherwise we use a constant.
	if (LoadString(G_hinstance, IDS_CONFIRMCLOSE, message, 512) == 0)
		strcpy(message,"Do you Want To Close This Application ?\n(but there is a problem to load resources)");
	//Open System Dialog Box 
	rep=MessageBox(hw,message,titre,MB_APPLMODAL | MB_YESNO | MB_ICONQUESTION);
	if (rep == IDNO) return;

	PostMessage(hw,WM_DESTROY,0,0L); //DestroyWindow(G_hwnd_MainWindow);
}

void ManageAboutBox(HWND hw)
{
	char titre[]="About...";
	char message[512];
	strcpy(message,SZPUBLICNAME);
	strcat(message,"\nVersion : ");
	strcat(message,SZPUBLICVERSION);
	strcat(message,"\nStandalone Application\n");
	strcat(message,"\nExample of 'C' Source code\n");
	
	MessageBox(hw,message,titre,MB_APPLMODAL | MB_OK | MB_ICONINFORMATION);
}

/*******************************************************************************/
/*******************************************************************************/
/*******************************************************************************/

void ManageMenu(HWND hw, WPARAM p,LPARAM w)
{
	char sss[256];
	HDC dc;
	switch(LOWORD(p))
	{
		case IDT_DOSOMETHING:
			dc=GetDC(hw);
			strcpy(sss,"I write something in the Client Area");
			TextOut(dc,0,0,sss,(int)strlen(sss));
			ReleaseDC(hw,dc);
			break;
		case IDM_QUIT:
			ManageCloseMessage(hw);
			break;
		case IDM_ABOUT:
			ManageAboutBox(hw);
			break;

	}
}

/*******************************************************************************/
/*******************************************************************************/
/*******************************************************************************/

BOOL InitSoftware(HWND hw)
{
	return TRUE;
}

BOOL EndSoftware(HWND hw)
{
	return TRUE;
}

/*******************************************************************************/
/*                                  CALL BACK                                  */
/*******************************************************************************/

LRESULT CALLBACK MainWindowManageEvent(HWND hw,			//handle of the window.
											UINT msg,   //Message Ident.
											WPARAM p1,	//parameter 1.
											LPARAM p2)	//parameter 2
{
	char sss[256];
	HDC dc;
	PAINTSTRUCT ps;
	switch (msg)
	{


		case WM_CREATE:
			if (InitSoftware(hw) == FALSE) return -1;//return -1 here cancel the window creation
			break;
		case WM_COMMAND:
			ManageMenu(hw,p1,p2);
			break;

		case WM_PAINT:
			dc=BeginPaint(hw,&ps);
			strcpy(sss,"This text is always displayed");
			TextOut(dc,0,30,sss,(int)strlen(sss));
			EndPaint(hw,&ps);
	        break;
		case WM_CLOSE:
			ManageCloseMessage(hw);
			break;
		case WM_DESTROY:
			EndSoftware(hw);
			PostQuitMessage(0);
			break;
		default:
			return (DefWindowProc(hw,msg,p1,p2));

	}
	return (0L);
}


/*******************************************************************************/
/**                              MAIN PROCDURE                                **/
/*******************************************************************************/

int APIENTRY WinMain(HINSTANCE handle_app,			//Application hinstance.
							HINSTANCE handle_prev,  //NULL.
							LPTSTR param,           //Command Line Parameter.
							int com_show)           //How to display window (optionnal).
{
	long	wstyle;
	MSG		msg;    
	char	szWindowClassName[]="MainWindowClass";
	char *	title="Sorry";

	WNDCLASS	wc;
	//we first store the APP Hinstance
	G_hinstance=handle_app;

	//here you can make some early initialization and analyze command line if any.

	//we define a window class to create a window from this class 
	wc.style		=CS_HREDRAW | CS_VREDRAW;  	  		//property.
	wc.lpfnWndProc=(WNDPROC)MainWindowManageEvent;		//Adresse of our Callback.
	wc.cbClsExtra =0;					  				//Possibility to store some byte inside a class object.
	wc.cbWndExtra =0;                          			//Possibility to store some byte inside a window object.
	wc.hInstance  =handle_app; 	                		//handle of the application hinstance.
	wc.hIcon      =LoadIcon(NULL, IDI_APPLICATION);    	//handle of icon displayed in the caption.
	wc.hCursor    =LoadCursor(NULL,IDC_ARROW);			//handle of cursor mouse .
	wc.hbrBackground=(HBRUSH)(COLOR_MENU+1);			//Background color.
	wc.lpszMenuName="MyMainAppMenu";    				//pointer on menu defined in resource.
	wc.lpszClassName=szWindowClassName;       			//pointer on class name.

	//register class.
	if (RegisterClass(&wc)==0)
	{
		MessageBox(NULL,"Failed to register main class...",title,MB_APPLMODAL | MB_OK | MB_ICONERROR);
		return 0;
	}
	//then we can create a windows from this class.
	
	//Classical Window without Sizing border.
	//wstyle=WS_DLGFRAME | WS_OVERLAPPED | WS_VISIBLE | WS_MINIMIZEBOX | WS_SYSMENU;
	
	//classical Main Window
	wstyle=WS_OVERLAPPEDWINDOW | WS_VISIBLE;
	G_hwnd_MainWindow=CreateWindow(szWindowClassName,	// address of registered class name.
						 SZPUBLICNAME,					// address of window name string
						 wstyle,						// window style
						 CW_USEDEFAULT,					// horizontal position of window
						 CW_USEDEFAULT,					// vertical position of window
						 UI_WIN_DX,						// window width
						 UI_WIN_DY,						// window height
						 NULL,							// parent handle is NULL since it's a main window.
						 NULL,							// menu name defined in resource (NULL if no menu or already defined in the Class).
						 handle_app,					// handle of application instance
						 NULL); 						// address of window-creation data

	if (G_hwnd_MainWindow==NULL)
	{
		MessageBox(NULL,"Failed to create window...",title,MB_APPLMODAL | MB_OK | MB_ICONERROR);
		return 0;
	}
	ShowWindow(G_hwnd_MainWindow,SW_SHOW);				//Display the window.
	UpdateWindow(G_hwnd_MainWindow);					//Send WM_PAINT.
	/*---------------------------------------------------------------------------*/
	/*                             Messages Loop.                                */
	/*---------------------------------------------------------------------------*/
	while (GetMessage(&msg,NULL,0,0))	//Get Message if any.
	{
		TranslateMessage(&msg);			//Translate the virtuel keys event.
		DispatchMessage(&msg);			//DispatchMessage to the related window.
	}

	//here you can make last uninitialization and release
	return (int)(msg.wParam);
}
